import { watch } from 'fs';
import { promises } from 'fs';

const readdir = promises.readdir;

type FileDiff = {
    name: string,
    desc: string
};

export class Watcher{
    private _path:string;
    private _added: FileDiff[];
    private _deleted: FileDiff[];
    constructor(path:string){
        this._path = path;
        this._added =[];
        this._deleted =[]
    }
    public get added() : FileDiff[] {
        return this._added;
    }
    /*public set added(diff : FileDiff[]) {
        this._added = diff;
    }*/
    public get deleted(): FileDiff[]{
        return this._deleted;
    }
    /*public set deleted(diff : FileDiff[]){
        this._deleted = diff;
    }*/
    public get path(){
        return this._path;
    }

    async setup(initial_filenames:string[]){
        const cur = (await readdir(this._path,{
            encoding:"utf8",
            withFileTypes: true,
        })).filter(x=>x.isFile).map(x=>x.name);
        let added = cur.filter(x => !initial_filenames.includes(x));
        let deleted = initial_filenames.filter(x=>!cur.includes(x));
        this._added = added.map(x=>{return {name:x,desc:""}});
        this._deleted = deleted.map(x=>{return {name:x,desc:""}});
        watch(this._path,{persistent: true, recursive:false},async (eventType,filename)=>{
            if(eventType === "rename"){
                const cur = (await readdir(this._path,{
                    encoding:"utf8",
                    withFileTypes: true,
                })).filter(x=>x.isFile).map(x=>x.name);
                if(cur.includes(filename)){
                    this._added.push({name:filename,desc:""});
                }
                else{
                    if(this._added.map(x=>x.name).includes(filename)){
                        this._added = this._added.filter(x=> x.name !== filename);
                    }
                    else {
                        this._deleted.push({name:filename,desc:""});
                    }
                }
            }
        });
    }
}

export class DiffWatcher{
    Watchers: {[basepath:string]:Watcher} = {};
}